//import processing.pdf.*;

//memory bank to store existing rectangles
int memx[] = new int[100];
int memy[] = new int[100];
int memw[] = new int[100];
int memh[] = new int[100];
int mem=0;

void memo(int x, int y, int w, int h){
     //memorize x,y,w,h as the mem-th rectangle
     memx[mem] = x;
     memy[mem] = y;
     memw[mem] = w;
     memh[mem] = h; 
     mem++;
}

boolean inside(int tx, int ty, int x, int y, int w, int h){
        //test whether a point tx,ty is inside a rectangle (x,y,w,h)
        if  ((tx >= x) && (tx <= x+w) && (ty >= y) && (ty <= y+h)) 
             return true;
        else return false;
} 

boolean accept(int x1, int y1, int w1, int h1, int x2, int y2, int w2, int h2){
        //test for two rectangles that no corner of one is inside the other;
        //they may still overlap as one can cross entirely through the other
        return !inside(x1    ,y1    ,x2,y2,w2,h2)
            && !inside(x1+w1 ,y1    ,x2,y2,w2,h2)
            && !inside(x1    ,y1+h1 ,x2,y2,w2,h2)
            && !inside(x1+w1 ,y1+h1 ,x2,y2,w2,h2)
            && !inside(x2    ,y2    ,x1,y1,w1,h1)
            && !inside(x2+w2 ,y2    ,x1,y1,w1,h1)
            && !inside(x2    ,y2+h2 ,x1,y1,w1,h1)
            && !inside(x2+w2 ,y2+h2 ,x1,y1,w1,h1);
}

boolean acceptable(int x, int y, int w, int h){
        //test for a new rectangle whether it is acceptable against all others in memory
        boolean okay = true;
        for (int i=0; i<mem; i++) {
            if (!accept(x,y,w,h,memx[i],memy[i],memw[i],memh[i])) 
               okay = false;
        }
        return okay;
} 

void myCluster(int cx, int cy){
     mem=0;
     int successes = 0;
     int howmany = int(random(15));
     while (successes < howmany) {
            //generate a rectangle
            int y = cy + int(random(-100,100));
            int x = cx + int(random(-150,150));
            int w = int(random(200));
            int h = int(random(100));
            //and test it
            if (acceptable(x,y,w,h)){
               rect(x,y,w,h); //draw it
               memo(x,y,w,h); //memorize it
               successes++;
            }
     }
}

void myArt(){
     int howmany = 1 + int(random(4));
     for (int j=0; j<howmany; j++){
         int cx = width/2 + int(random(-width/4,width/4));
         int cy = height/2 + int(random(-height/4,height/4));
         myColor(j);
         pushMatrix();
         rotate(radians(int(random(40))));
         myCluster(cx, cy);
         popMatrix();
     }
     print("how many clusters: "); println(howmany);
}



void setup() {
     size(400,500);
     //size(400, 500, PDF, "malevich.pdf");
     background(220);   
     myArt();
}

void myColor(int i){
      color c = color(0,0,0);
      switch (i % 5) {
        case 0: c = color(20,20,20);  break;//black
        case 1: c = color(200,0,25);  break;//red-ish
        case 2: c = color(220,175,0); break;//yellow-ish
        case 3: c = color(0,0,150);   break;//blue-ish
        case 4: c = color(0,125,0);   break;//green-ish
      }
      stroke(0);
      fill(c);
}
